Codeforces Round #521 (Div. 3) E. Thematic Contests(dp)

传送门

思路
这个题因为ai是从1 - > 1e9的刚开始想用vector离散化,后来发现只用记录次数就可以了;
因为数据范围比较大,所以使用成一维的;

dp[j] 最后一天的题目数量为j 所满足条件的最大问题数量
dp[j] = max(dp[j],dp[j / 2] + j);

Code:

#include <iostream>
#include <cstring>
#include <cmath>
#include <cstdio>
#include <string>
#include <algorithm>
#include <queue>
#include <utility>
#include <stack>
#include <map>
#include <cmath>
#include <numeric>
#define mes memset
#define mec memcpy
  
using namespace std;
  
typedef long long ll;
typedef pair<int,int>PII;
  
const int N = 2e5 + 10;
const int null = 0x3f3f3f3f;
const ll mod = 1e6 + 7;
 
int n;
ll a[N],b[N];
ll dp[N];
 
int main()
{
    cin >> n;
    for(int i = 1;i <= n;i ++) cin >> a[i];
	sort(a + 1,a + n + 1);
	int k = 0,t = 0;
	for(int i = 1;i < n;i ++)
	{
		if(a[i] != a[i + 1])
		{
			//记录出现了多少次,也就是这种类型的题有多少种
			b[k ++] = i - t;
			t = i;
		}
	}
	
	b[k ++] = n - t;
	//种数从小到大排序
	sort(b,b + k);
	ll mmax = 0;
	for(int i = 0;i < k;i ++)
	{
		//因为要的上一个状态的j/2,所以从大到小枚举
		for(int j = b[i];j > 0;j --)
		{
			//如果可以整除2则取以j个题数结尾和以j/2个题数结尾+j的最大值
			//如果不能整除,则以j个题数结尾的满足条件的只有j种
			if(j % 2 == 0) dp[j]  = max(dp[j],dp[j / 2] + j);
			else dp[j] = j;
	
			mmax = max(mmax,dp[j]);
		}
	}
	
	cout << mmax << endl;
    return 0;
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

半碗无糖蓝莓冻

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值